<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item label="排程id" prop="schedulingId">
              <el-input v-model="queryParams.schedulingId" placeholder="请输入排程id" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="设备id" prop="deviceId">
              <el-input v-model="queryParams.deviceId" placeholder="请输入设备id" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['app:schedulingDevice:add']">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate()" v-hasPermi="['app:schedulingDevice:edit']">修改</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()" v-hasPermi="['app:schedulingDevice:remove']">删除</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['app:schedulingDevice:export']">导出</el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="schedulingDeviceList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="排程id" align="center" prop="schedulingId" />
        <el-table-column label="设备id" align="center" prop="deviceId" />
        <el-table-column label="操作" align="center" fixed="right"  class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['app:schedulingDevice:edit']"></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['app:schedulingDevice:remove']"></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改排程与设备关联对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="schedulingDeviceFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="排程id" prop="schedulingId">
          <el-input v-model="form.schedulingId" placeholder="请输入排程id" />
        </el-form-item>
        <el-form-item label="设备id" prop="deviceId">
          <el-input v-model="form.deviceId" placeholder="请输入设备id" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="SchedulingDevice" lang="ts">
import { listSchedulingDevice, getSchedulingDevice, delSchedulingDevice, addSchedulingDevice, updateSchedulingDevice } from '@/api/app/schedulingDevice';
import { SchedulingDeviceVO, SchedulingDeviceQuery, SchedulingDeviceForm } from '@/api/app/schedulingDevice/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const schedulingDeviceList = ref<SchedulingDeviceVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const schedulingDeviceFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: SchedulingDeviceForm = {
  schedulingId: undefined,
  deviceId: undefined,
}
const data = reactive<PageData<SchedulingDeviceForm, SchedulingDeviceQuery>>({
  form: {...initFormData},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    schedulingId: undefined,
    deviceId: undefined,
    params: {
    }
  },
  rules: {
    schedulingId: [
      { required: true, message: "排程id不能为空", trigger: "blur" }
    ],
    deviceId: [
      { required: true, message: "设备id不能为空", trigger: "blur" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询排程与设备关联列表 */
const getList = async () => {
  loading.value = true;
  const res = await listSchedulingDevice(queryParams.value);
  schedulingDeviceList.value = res.rows;
  total.value = res.total;
  loading.value = false;
}

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
}

/** 表单重置 */
const reset = () => {
  form.value = {...initFormData};
  schedulingDeviceFormRef.value?.resetFields();
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
}

/** 多选框选中数据 */
const handleSelectionChange = (selection: SchedulingDeviceVO[]) => {
  ids.value = selection.map(item => item.schedulingId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = "添加排程与设备关联";
}

/** 修改按钮操作 */
const handleUpdate = async (row?: SchedulingDeviceVO) => {
  reset();
  const _schedulingId = row?.schedulingId || ids.value[0]
  const res = await getSchedulingDevice(_schedulingId);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = "修改排程与设备关联";
}

/** 提交按钮 */
const submitForm = () => {
  schedulingDeviceFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.schedulingId) {
        await updateSchedulingDevice(form.value).finally(() =>  buttonLoading.value = false);
      } else {
        await addSchedulingDevice(form.value).finally(() =>  buttonLoading.value = false);
      }
      proxy?.$modal.msgSuccess("操作成功");
      dialog.visible = false;
      await getList();
    }
  });
}

/** 删除按钮操作 */
const handleDelete = async (row?: SchedulingDeviceVO) => {
  const _schedulingIds = row?.schedulingId || ids.value;
  await proxy?.$modal.confirm('是否确认删除排程与设备关联编号为"' + _schedulingIds + '"的数据项？').finally(() => loading.value = false);
  await delSchedulingDevice(_schedulingIds);
  proxy?.$modal.msgSuccess("删除成功");
  await getList();
}

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download('app/schedulingDevice/export', {
    ...queryParams.value
  }, `schedulingDevice_${new Date().getTime()}.xlsx`)
}

onMounted(() => {
  getList();
});
</script>
